/* dgramrcv.c - receive from udp server
 *
 * author: hackbard
 *
 */

#include <stdio.h>
#include <stdlib.h>

/* memset */
#include <string.h>

/* socket and bind stuff */
#include <sys/types.h>
#include <sys/socket.h>

/* sockkaddr_in */
#include <netinet/in.h>

/* inet_ntoa ... */
#include <arpa/inet.h>

/* errno stuff ... */
#include <errno.h>

/* read, close */
#include <unistd.h>

int main(int argc, char *argv[]) {
  int receive_fd;
  int opt;
  struct sockaddr_in local_addr,target_addr;
  int receive_bytes, write_bytes;
  socklen_t target_addr_len;

  if(argc!=2) {
    printf("usage: %s <port>\n",argv[0]);
    exit(1);
  }

  if((receive_fd=socket(AF_INET,SOCK_DGRAM,0)) == -1) {
    printf("can't open socket.\n");
    exit(1);
  }

  opt=1;
  setsockopt(receive_fd,SOL_SOCKET,SO_BROADCAST,&opt,sizeof(opt));

  local_addr.sin_family=AF_INET;
  local_addr.sin_port=htons(atoi(argv[1]));
  local_addr.sin_addr.s_addr=htonl(INADDR_ANY);
  bind(receive_fd,(const struct sockaddr *)&local_addr,sizeof(local_addr));
 
  memset(&target_addr,0,sizeof(target_addr));
  target_addr.sin_family=AF_INET;
  target_addr.sin_port=htons(atoi(argv[1]));
  target_addr.sin_addr.s_addr=inet_addr(argv[1]);
  target_addr_len=sizeof(target_addr);

  receive_bytes=1;
  while(receive_bytes>0) {
	unsigned char buf[1000];
	receive_bytes=recvfrom(receive_fd,buf,sizeof(buf),0,(struct sockaddr *)&target_addr,&target_addr_len);
        write_bytes=write(1,buf,receive_bytes);
  }

  close(receive_fd);
  printf("connection closed ...\n");
  printf("%d from %d total bytes written.\n",write_bytes,receive_bytes);
  
  return 0;
}
